// FILENAME:	ION_Cold_Titan_Night.cs
//
// AUTHOR:  	Gen. Raven [M.I.B.]
//
// RANDOM THOUGHT #1: If d = vt, why isn't the pizza guy here yet?
//
// RANDOM THOUGHT #2: Did you know that meteors travel at a constant 
// velocity of 400 m/s?.....Now you do :)
//------------------------------------------------------------------------------
// Stealth Detection - Set to true & players with a "/" in front of their
// will be detected when they join or leave the server.

$stealthDetect = true;    //Set to false to turn off stealth detection

//------------------------------------------------------------------------------
$missionName = "ION_Cold_Titan_Night";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = true;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = false;
   $server::disableTeamPurple = false;
}

function onMissionStart()
{
      // DM_Cold_Titan_Night stuff
      $healRate = 100;   
	$ammoRate = 3;
   	$padWaitTime = 45;
  	$zenWaitTime = 90;

      titanSounds();
}

function onMissionLoad()
{
   cdAudioCycle("Mechsoul", "Terror", "NewTech"); 
   setGameInfo("<F2>GAME TYPE:<F0>  DeathMatch\n\n<F2>MISSION:<F0>  ION_Cold_Titan_Night\n\nWelcome to Ion Cannon Deathmatch! You can fire your Ion Cannon by scanning vehicles or structures, or by spotting them with LTADs. Your Ion Cannon must recharge for 90 seconds after each use. You can download ION_Cold_Titan_Night & other missions made by Gen. Raven [M.I.B.] in the \"MIB Map Packs\" at www.starsiegeplayers.com or on the MIB Website at www.starsiegemeninblack.cjb.net.");
   //reset the boomkills
   %count = playerManager::getPlayerCount();
   for(%i = 0; %i < %count; %i++)
   {
      %player = playerManager::getPlayerNum(%i);
      %player.boomkill = 0;
   }
}

function player::onadd(%player)
{
   if(($stealthDetect == true)&&(strAlign(1, left, getname(%player))=="/"))
   {
        say(0,0,"<f4>"@getname(%player)@" joined the game","alarm2.wav");
        messagebox(%player,"This server is equipped with an anti-stealth detection system. The slash on your name has been detected. All players have been alerted to your presence.");
        say(%player,0,"Welcome to Ion Cannon Deathmatch! You can fire your Ion Cannon by scanning vehicles or structures, or by spotting them with LTADs. Your Ion Cannon must recharge for 90 seconds after each use. You can download ION_Cold_Titan_Night & other missions made by Gen. Raven [M.I.B.] in the \"MIB Map Packs\" at www.starsiegeplayers.com or on the MIB Website at www.starsiegemeninblack.cjb.net.");
   }
   else
   {
      say(%player,0,"Welcome to Ion Cannon Deathmatch! You can fire your Ion Cannon by scanning vehicles or structures, or by spotting them with LTADs. Your Ion Cannon must recharge for 90 seconds after each use. You can download ION_Cold_Titan_Night & other missions made by Gen. Raven [M.I.B.] in the \"MIB Map Packs\" at www.starsiegeplayers.com or on the MIB Website at www.starsiegemeninblack.cjb.net.");
   }
   %player.boomkill = 0;
}

function player::onremove(%player)
{
   if(($stealthDetect == true)&&(strAlign(1, left, getname(%player))=="/"))
   {
      say(0,0,"<f4>"@getname(%player)@" left the game","alarm2.wav");
   }
}

function vehicle::onadd(%vehicleId)
{
   %player = playermanager::vehicleIdtoPlayerNum(%vehicleId);
   %vehicleId.ready = true;
   sethudtimer(0,0,"Ion Cannon Online",2,%player);
}

function vehicle::onspot(%spotter,%target)
{
    %player = playermanager::vehicleIdtoPlayerNum(%spotter);
    %player2 = playermanager::vehicleIdtoPlayerNum(%target);
    if($server::Teamplay==false)
    {
       if(%target!="")
       {
           if(%spotter.ready==true)
           {
               %target.killer = getname(%spotter);
               %player2.killer2 = %player;
               %spotter.ready = false;
               %spotterX = getposition(%spotter,x);
               %spotterY = getposition(%spotter,y);
               %spotterZ = getposition(%spotter,z)+10;
               %targetX = getposition(%target,x);
               %targetY = getposition(%target,y);
               %targetZ = getposition(%target,z);
               droppod(%spotterX,%spotterY,%spotterZ,%targetX,%targetY,%targetZ);
               %distance = getdistance(%spotter,%target);
               %time = %distance / 400; //400 m/s (speed of drop pod)
               schedule("damagearea("@%target@",0,0,0,150,875);",%time);
               schedule("playSound(%player2, \"explo3.wav\", IDPRF_2D);",%time);
               %spotter.firetime = getcurrenttime();
               schedule("ready("@%spotter@");",90);
               sethudtimer(90,-1,"Ion Cannon Recharging",2,%player);
               playSound(%player, "sfx_shrk.wav", IDPRF_2D);
           }
           else if(%spotter.ready==false)
           {
               %spotter.nowtime  = getcurrenttime();
               %spotter.timecharged = %spotter.nowtime - %spotter.firetime;
               %spotter.timeleft = 90 - %spotter.timecharged;
               say(%player,%player,"<f1>Ion Cannon charging - " @ %spotter.timeleft @ " seconds remaining.");
           }
       }
    }
    else if(($server::TeamPlay == true) && (getTeam(%spotter) != getTeam(%target)))
    {
       if(%target!="")
       {
           if(%spotter.ready==true)
           {
               %target.killer = getname(%spotter);
               %player2.killer2 = %player;
               %spotter.ready = false;
               %spotterX = getposition(%spotter,x);
               %spotterY = getposition(%spotter,y);
               %spotterZ = getposition(%spotter,z)+10;
               %targetX = getposition(%target,x);
               %targetY = getposition(%target,y);
               %targetZ = getposition(%target,z);
               droppod(%spotterX,%spotterY,%spotterZ,%targetX,%targetY,%targetZ);
               %distance = getdistance(%spotter,%target);
               %time = %distance / 400; //400 m/s (speed of drop pod)
               schedule("damagearea("@%target@",0,0,0,150,875);",%time);
               schedule("playSound(%player2, \"explo3.wav\", IDPRF_2D);",%time);
               %spotter.firetime = getcurrenttime();
               schedule("ready("@%spotter@");",90);
               sethudtimer(90,-1,"Ion Cannon Recharging",2,%player);
               playSound(%player, "sfx_shrk.wav", IDPRF_2D);
           }
           else if(%spotter.ready==false)
           {
               %spotter.nowtime  = getcurrenttime();
               %spotter.timecharged = %spotter.nowtime - %spotter.firetime;
               %spotter.timeleft = 90 - %spotter.timecharged;
               say(%player,%player,"<f1>Ion Cannon charging - " @ %spotter.timeleft @ " seconds remaining.");
           }
       }
   }          
   else
   {
      say(%player,%player,"<f5>You cannot fire on your own team!");
   } 
}

function vehicle::onscan(%scanned,%scanner)
{
    %player = playermanager::vehicleIdtoPlayerNum(%scanner);
    %player2 = playermanager::vehicleIdtoPlayerNum(%scanned);
    if($server::Teamplay==false)
    {
       if(%scanner.ready==true)
       {
           %scanned.killer = getname(%scanner);
           %player2.killer2 = %player;
           %scanner.ready = false;
           %scannerX = getposition(%scanner,x);
           %scannerY = getposition(%scanner,y);
           %scannerZ = getposition(%scanner,z)+10;
           %scannedX = getposition(%scanned,x);
           %scannedY = getposition(%scanned,y);
           %scannedZ = getposition(%scanned,z);
           droppod(%scannerX,%scannerY,%scannerZ,%scannedX,%scannedY,%scannedZ);
           %distance = getdistance(%scanner,%scanned);
           %time = %distance / 400; //400 m/s (speed of drop pod)
           schedule("damagearea("@%scanned@",0,0,0,150,875);",%time);
           schedule("playSound(%player2, \"explo3.wav\", IDPRF_2D);",%time);
           %scanner.firetime = getcurrenttime();
           schedule("ready2("@%scanner@");",90);
           sethudtimer(90,-1,"Ion Cannon Recharging",2,%player);
           playSound(%player, "sfx_shrk.wav", IDPRF_2D);
       }
       else if(%scanner.ready==false)
       {
           %scanner.nowtime  = getcurrenttime();
           %scanner.timecharged = %scanner.nowtime - %scanner.firetime;
           %scanner.timeleft = 90 - %scanner.timecharged;
           say(%player,%player,"<f1>Ion Cannon charging - " @ %scanner.timeleft @ " seconds remaining.");
       }
    }
    else if(($server::TeamPlay == true) && (getTeam(%scanner) != getTeam(%scanned)))
    {
       if(%scanner.ready==true)
       {
           %scanned.killer = getname(%scanner);
           %player2.killer2 = %player;
           %scanner.ready = false;
           %scannerX = getposition(%scanner,x);
           %scannerY = getposition(%scanner,y);
           %scannerZ = getposition(%scanner,z)+10;
           %scannedX = getposition(%scanned,x);
           %scannedY = getposition(%scanned,y);
           %scannedZ = getposition(%scanned,z);
           droppod(%scannerX,%scannerY,%scannerZ,%scannedX,%scannedY,%scannedZ);
           %distance = getdistance(%scanner,%scanned);
           %time = %distance / 400; //400 m/s (speed of drop pod)
           schedule("damagearea("@%scanned@",0,0,0,150,875);",%time);
           schedule("playSound(%player2, \"explo3.wav\", IDPRF_2D);",%time);
           %scanner.firetime = getcurrenttime();
           schedule("ready2("@%scanner@");",90);
           sethudtimer(90,-1,"Ion Cannon Recharging",2,%player);
           playSound(%player, "sfx_shrk.wav", IDPRF_2D);
       }
       else if(%scanner.ready==false)
       {
           %scanner.nowtime  = getcurrenttime();
           %scanner.timecharged = %scanner.nowtime - %scanner.firetime;
           %scanner.timeleft = 90 - %scanner.timecharged;
           say(%player,%player,"<f1>Ion Cannon charging - " @ %scanner.timeleft @ " seconds remaining.");
       }
   }
   else
   {
      say(%player,%player,"<f5>You cannot fire on your own team!");
   } 
}

function structure::onscan(%scanned,%scanner)
{
    %player = playermanager::vehicleIdtoPlayerNum(%scanner);
    if(%scanner.ready==true)
    {
        %scanner.ready = false;
        %scannerX = getposition(%scanner,x);
        %scannerY = getposition(%scanner,y);
        %scannerZ = getposition(%scanner,z)+10;
        %scannedX = getposition(%scanned,x);
        %scannedY = getposition(%scanned,y);
        %scannedZ = getposition(%scanned,z);
        droppod(%scannerX,%scannerY,%scannerZ,%scannedX,%scannedY,%scannedZ);
        %distance = getdistance(%scanner,%scanned);
        %time = %distance / 400; //400 m/s (speed of drop pod)
        schedule("damagearea("@%scanned@",0,0,0,150,875);",%time);
        schedule("damageobject("@%scanned@",100000);",%time);
        %scanner.firetime = getcurrenttime();
        schedule("ready2("@%scanner@");",90);
        sethudtimer(90,-1,"Ion Cannon Recharging",2,%player);
        playSound(%player, "sfx_shrk.wav", IDPRF_2D);
    }
    else if(%scanner.ready==false)
    {
        %scanner.nowtime  = getcurrenttime();
        %scanner.timecharged = %scanner.nowtime - %scanner.firetime;
        %scanner.timeleft = 90 - %scanner.timecharged;
        say(%player,%player,"<f1>Ion Cannon charging - " @ %scanner.timeleft @ " seconds remaining.");
    }
}

function ready(%spotter)
{  
      %spotter.ready = true;      
}

function ready2(%scanner)
{  
      %scanner.ready = true;      
}

function vehicle::onDestroyed(%destroyed, %destroyer)
{
   // left over from missionStdLib.cs
   vehicle::onDestroyedLog(%destroyed, %destroyer);
   
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   %player2 = playermanager::vehicleIdtoPlayerNum(%destroyed);
   if(%player == 0)
   {
      %random = randomInt(0,2); 
      if(%destroyed.killer != "")
      {
         if(%random == 0)
         {
            say(0,2,"<f0>" @ %destroyed.killer @ " annihilated " @ gethudname(%destroyed) @ " with his Ion Cannon.","sfx_fog.wav");
         }
         else if(%random == 1)
         {
            say(0,2,"<f0>" @ gethudname(%destroyed) @ " was destroyed by " @ %destroyed.killer @ "'s Ion Cannon.","sfx_fog.wav");
         }
         else if(%random == 2)
         {
            say(0,2,"<f0>" @ gethudname(%destroyed) @ " didnt see " @ %destroyed.killer @ "'s Ion Cannon until it was too late.","sfx_fog.wav");    
         }
      }
      else if(%destroyed.killer == "")
      {
         say(0,2,"<f0>" @ gethudname(%destroyed) @ " got caught in an ionic shockwave.","sfx_fog.wav");    
      }
      
      %killer = %player2.killer2;
      %killer.boomkill = %killer.boomkill + 3;
   }
   else
   {   
      // this is weird but %destroyer isn't necessarily a vehicle
      %message = getFancyDeathMessage(getHUDName(%destroyed), getHUDName(%destroyer));
      if(%message != "")
      {
         say( 0, 0, %message);
      }
      // enforce the rules
      if($server::TeamPlay == true)
      {
         if((getTeam(%destroyed) == getTeam(%destroyer))&&(%destroyed != %destroyer))
         {
            antiTeamKill(%destroyer);
         }
      }   
   }
}

function getPlayerScore(%player)
{
   return((getKills(%player) * $killPoints) - (getDeaths(%player) * $deathPoints)) + %player.boomkill;
}

// DM_Cold_Titan_Night stuff
// Healing Pad Functionality
//------------------------------------------------------------------------------
function ZenHeal::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_HEALPAD, true, true);  
}
function ZenHeal::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, 0, $padWaitTime, true); 
}

// Ammo Pad Functionality
//------------------------------------------------------------------------------
function ZenAmmo::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_AMMOPAD, true, true);  
}

function ZenAmmo::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 0, $ammoRate, $padWaitTime, true); 
}

// ZenAll Pad Functionality
//------------------------------------------------------------------------------
function ZenAll::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);  
}
function ZenAll::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, $ammoRate, $padWaitTime, true); 
}

//If someone shoots frosty, his houses blow up revealing a nasty surprise
//------------------------------------------------
function tur1::turret::onAdd(%this)
{
	$turret1=%this;
	order($turret1,ShutDown,true);
}
function tur2::turret::onAdd(%this)
{
	$turret2=%this;
	order($turret2,ShutDown,true);
}
function Frosty::structure::onAttacked(%attacked,%attacker)
{
	%bang1=getObjectId("MissionGroup\\extra\\frosty's house\\house1");
	healObject(%bang1,-30000);
	order($turret1,ShutDown,false);
	order($turret1, Attack, %attacker);
	%bang2=getObjectId("MissionGroup\\extra\\frosty's house\\house2");
	healObject(%bang2,-30000);
	order($turret2,ShutDown,false);
	order($turret2, Attack, %attacker);
}